d = Uniform([1])

@test rand(d) == 1
@test rand(MersenneTwister(4), d) == 1
@test collect(support(d)) == [1]
@test sampletype(d) == typeof(1)
@test sampletype(typeof(d)) == typeof(1)
@test pdf(d, 0) == 0.0
@test pdf(d, 1) == 1.0
@test mode(d) == 1
@test mean(d) == 1
@test typeof(mean(d)) == typeof(mean([1]))
@test collect(weighted_iterator(d)) == [1=>1.0]

d2 = Uniform((:symbol,))
@test rand(d2) == :symbol
@test rand(MersenneTwister(4), d2) == :symbol
@test collect(support(d2)) == [:symbol]
@test sampletype(d2) == typeof(:symbol)
@test sampletype(typeof(d2)) == typeof(:symbol)
@test pdf(d2, :another) == 0.0
@test pdf(d2, :symbol) == 1.0
@test mode(d2) == :symbol
@test collect(weighted_iterator(d2)) == [:symbol=>1.0]

# uniqueness test
@test_throws ErrorException Uniform((:symbol, :symbol))

d3 = UnsafeUniform([1])

@test rand(d3) == 1
@test rand(MersenneTwister(4), d3) == 1
@test collect(support(d3)) == [1]
@test sampletype(d3) == typeof(1)
@test sampletype(typeof(d3)) == typeof(1)
@test pdf(d3, 1) == 1.0
@test mean(d3) == 1
@test mode(d3) == 1
@test typeof(mean(d3)) == typeof(mean([1]))
@test collect(weighted_iterator(d3)) == [1=>1.0]

d4 = UnsafeUniform((:symbol,))
@test rand(d4) == :symbol
@test rand(MersenneTwister(4), d4) == :symbol
@test collect(support(d4)) == [:symbol]
@test sampletype(d4) == typeof(:symbol)
@test sampletype(typeof(d4)) == typeof(:symbol)
# @test pdf(d4, :another) == 0.0 # this will not work
@test pdf(d4, :symbol) == 1.0
@test mode(d4) == :symbol
@test collect(weighted_iterator(d4)) == [:symbol=>1.0]
